#include <windows.h>
#include "GMLuaModule.h"
#include <string>

#define MOUSE_LEFT 107
#define MOUSE_RIGHT 108
#define MOUSE_MIDDLE 109

// This is a macro to make life easier.
// When the dll is loaded it will call the function (Init)
GMOD_MODULE( Init, Shutdown );

LUA_FUNCTION(Click)
{
	int button = g_Lua->GetInteger(1);

	switch (button)
	{
		case MOUSE_LEFT:
			mouse_event(MOUSEEVENTF_LEFTDOWN | MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
			g_Lua->Push(true);
			break;

		case MOUSE_RIGHT:
			mouse_event(MOUSEEVENTF_RIGHTDOWN | MOUSEEVENTF_RIGHTUP, 0, 0, 0, 0);
			g_Lua->Push(true);
			break;

		case MOUSE_MIDDLE:
			mouse_event(MOUSEEVENTF_MIDDLEDOWN | MOUSEEVENTF_MIDDLEUP, 0, 0, 0, 0);
			g_Lua->Push(true);
			break;

		default:
			g_Lua->Push(false);
	}

	return 0;
}

LUA_FUNCTION(Press)
{
	int button = g_Lua->GetInteger(1);

	switch (button)
	{
		case MOUSE_LEFT:
			mouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
			g_Lua->Push(true);
			break;

		case MOUSE_RIGHT:
			mouse_event(MOUSEEVENTF_RIGHTDOWN, 0, 0, 0, 0);
			g_Lua->Push(true);
			break;

		case MOUSE_MIDDLE:
			mouse_event(MOUSEEVENTF_MIDDLEDOWN, 0, 0, 0, 0);
			g_Lua->Push(true);
			break;

		default:
			g_Lua->Push(false);
	}

	return 0;
}

LUA_FUNCTION(Release)
{
	int button = g_Lua->GetInteger(1);

	switch (button)
	{
		case MOUSE_LEFT:
			mouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
			g_Lua->Push(true);
			break;

		case MOUSE_RIGHT:
			mouse_event(MOUSEEVENTF_RIGHTUP, 0, 0, 0, 0);
			g_Lua->Push(true);
			break;

		case MOUSE_MIDDLE:
			mouse_event(MOUSEEVENTF_MIDDLEUP, 0, 0, 0, 0);
			g_Lua->Push(true);
			break;

		default:
			g_Lua->Push(false);
	}

	return 0;
}

// When the DLL is initialized it will call this function to set itself up.
// It should be used to set up your library so it's all ready to go.
int Init( void )
{
	// Msg is defined in GMLuaModule.h
	// It's actually calling the Lua function, Msg
	Msg("gmcl_mouseclick loaded\n");

	// Lets make a global table filled with functions (a module)
	g_Lua->NewGlobalTable("mouse");
	ILuaObject* table = g_Lua->GetGlobal("mouse");
		table->SetMember("Click", Click);	
		table->SetMember("Press", Press);
		table->SetMember("Release", Release);

	// We're not deleting the table here - we're deleting the reference to it.
	// If you don't do this you're leaking memory.
	SAFE_UNREF( table );

	return 0;
}

// When the DLL is shutdown it calls this function.
// g_Lua should be assumed to have been released here
int Shutdown( void )
{

	return 0;
}